class MyException extends Exception {
}


class ExceptionDemo {

    void compute(int a, int b) throws MyException {
	System.out.print(a + " / " + b + " = ");
	try {
	    System.out.println(a / b);
	    if (a > 10)
		return;
	} catch (ArithmeticException e) {
	    System.out.println("Inf");
	    System.out.println("throwing MyException");
	    throw new MyException();
	} finally {
	    System.out.println("finally in compute()");
	}
	System.out.println("leaving compute() normally");
    }

    ExceptionDemo() throws MyException {
	compute(10, 2);
	compute(20, 4);
	compute(10, 0);
    }

    public String toString() {
	return "ExceptionDemo";
    }

    public static void main(String args[]) {
	ExceptionDemo ex;
	try {
	    ex = new ExceptionDemo();
	} catch (MyException e) {
	    System.out.println("caught MyException.");
	    ex = null;
	}
	System.out.println("ex = " + ex);
    }
}

