class Hex {
    static char hex[] = {
	'0', '1', '2', '3', '4', '5', '6', '7',
	'8', '9', 'a', 'b', 'c', 'd', 'e', 'f'
    };
    static String byteToHex(byte b) {
	return "" + hex[(b & 0xf0) >> 4] + hex[b&0xf];
    }
    static String byteToHex(byte b[]) {
	String tmpstr = "";
	for (int i=0; i < b.length; i++) {
		tmpstr += byteToHex(b[i]) + " ";
	}
	return tmpstr;
    }
    static String shortToHex(short s) {
	return byteToHex((byte)(s>>8)) + byteToHex((byte)s);
    }
    static String charToHex(char c) {
	return byteToHex((byte)(c>>8)) + byteToHex((byte)c);
    }
    static String intToHex(int i) {
	return shortToHex((short)(i>>16)) + shortToHex((short)i);
    }
    static String longToHex(long l) {
	return intToHex((int)(l>>32)) + intToHex((int)l);
    }
    static public void main(String args[]) {
	byte b = (byte) 0xf1;
	short s = (short) 0xf123;
	char c = 'A';
	int i = (int) 0xf1234567;
	long l = 0xfedcba9876543210L;
	System.out.println("b = " + byteToHex(b));
	System.out.println("s = " + shortToHex(s));
	System.out.println("c = " + charToHex(c));
	System.out.println("i = " + intToHex(i));
	System.out.println("l = " + longToHex(l));
    }
}
